﻿using System;

using System.Net.Sockets ;
using System.IO ;

namespace cClient
{
	/// <summary>
	/// Summary description for FTPThread.
	/// </summary>
	public class FTPThread
	{
		
		public Socket socketForClient;
		private StreamReader streamreader;
		private StreamWriter streamwriter;

		public frmMain mainForm;

		public FTPThread()
		{
			
		}
		public void closeConnections()
		{
			if(streamreader != null)
				streamreader.Close();
			if(streamwriter != null)
				streamwriter.Close();
			if(socketForClient!=null && socketForClient.Connected)
				socketForClient.Close();
			mainForm = null;
		}
		public void run()
		{
			NetworkStream networkStream = new NetworkStream(socketForClient) ;					
			streamreader = new StreamReader(networkStream) ;
			streamwriter = new StreamWriter(networkStream) ;

			System.IO.FileStream outFile; 


			string clientFile = null;
			string fileName = null;
			string hashValue = null;
			string userName = null;

			//read the user name
			userName = streamreader.ReadLine();

			//read the file name
			fileName = streamreader.ReadLine();

			//get the file hash
			hashValue = streamreader.ReadLine();

			//get the file
			clientFile = streamreader.ReadLine();

			if(Protocol.SimpleHash.VerifyHash(clientFile,"MD5",hashValue))
			{
				mainForm.fileReceivedMessage(userName);
				string  outputFileName=@"c:\temp\" + fileName;
				outFile = new FileStream(outputFileName, FileMode.CreateNew);
				//outFile.Write(base64String);
				byte [] data = System.Convert.FromBase64String(clientFile);

				outFile.Write(data, 0, data.Length);
				outFile.Close();
				mainForm.fileSavedMessage(fileName);
			}
			closeConnections();
		}
	}
}
